;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Capacitive sensor experiment (comparator)
;

;
; A capacitive sensor is connected between RA1/AN1 and VDD, with a 1-3M
; parallel resistor. We measure the time until the capacitor charges to a
; threshold value.
;

cap_comp_xp:
;	call	button		; button pressed ?
;	btfss	STATUS,C
;	goto	ui_off		; no -> power down

	; configure RA0/AN0 and RA1/AN1 as inputs to the comparators

	bsf	STATUS,RP0
	movlw	(1 << C2INV) | (2 << CM0)
	movwf	CMCON

	; configure the voltage reference to CVrsrc/2

	movlw	(1 << CVREN) | (0 << CVRR) | (15 << CVR0)
	movwf	CVRCON

	; make RA1/AN1 an output

	bcf	TRISA,1
	bcf	STATUS,RP0

	; load the capacitor

	call	lightsout

	bcf	PORTA,1		; this is almost instantaneous

	clrw			; set up an 8 bit counter in W

	; prepare to input

	bsf	STATUS,RP0
	bsf	TRISA,1

ccxlp:
	btfsc	CMCON,C2OUT	; are we done ?
	goto	ccxdone
	addlw	1		; count
	goto	ccxlp

ccxdone:
	bcf	STATUS,RP0
	movwf	tmp		; find the highest bit we got
	clrw

ccxfls:
	movf	tmp,F		; tmp == 0 ?
	btfsc	STATUS,Z
	goto	ccxflsdn
	addlw	1
	rrf	tmp,F		; tmp >>= 1
	goto	ccxfls

ccxflsdn:
	movwf	tmp		; save the result

	; make RA1/AN1 an output

	bsf	STATUS,RP0
	bsf	TRISA,1

	; turn off the voltage reference

	clrf	CVRCON

	; disable the comparator

	movlw	7
	movwf	CMCON
	bcf	STATUS,RP0

	movf	tmp,W		; show what we got
	call	setwth
	movlw	14		; hold display for 9 ms
	call	waitw

	goto	cap_comp_xp	; repeat
